<template>
  <div class="box p-5 md:p-8 mb-10 bg-white shadow-md rounded-lg">
    <form @submit.prevent="form.post(`/form/filledForm/${filledForm.id}`, { preserveScroll: true })">
      <h3 class="text-2xl font-semibold text-gray-800 mb-6">Submit Form</h3>

      <div v-for="approval in approvals" :key="approval.stage" class="mb-4">
        <div class="text-base font-bold text-gray-700 mb-3 mt-5">Approvers</div>
        <Icon icon="fa-solid fa-user" class="text-sm text-gray-500"></Icon>
        <span class="text-sm" v-if="approval.user">{{ approval.user.name }} ({{ approval.user.role.name }})</span>
        <span class="text-sm text-red-500" v-else>(User not found!)</span>
        <Status :status="approval.status" class="ml-2"></Status>
      </div>

      <!-- Dynamic fields -->
      <div v-if="formFields.length > 0">
        <div class="text-base font-bold text-gray-700 mb-3 mt-5">( <span class="text-orange-500">*</span> means that it is required)</div>
        <div class="space-y-7">
          <div v-for="(formField, index) in formFields" :key="index">
            <label v-if="formField.field.type === 'Title'" class="text-gray-600 text-lg font-bold italic">
              {{ formField.field.name }}
            </label>
            <label v-else-if="formField.field.type === 'Description'" class="text-gray-500 text-base">
              {{ formField.field.name }}
            </label>
            <label v-else class="block text-base font-medium text-gray-700" :class="{ 'opacity-30': formField.foreigner_field && form.nationality === 'Bhutanese' }">
              {{ index + 1 - formFields.slice(0, index).filter(rf => rf.field.type === 'Title' || rf.field.type === 'Description').length }}. {{ formField.field.name }}
              <span v-if="formField.field.required" class="text-lg text-orange-500">*</span>
            </label>
            <fieldset class="mb-1" :disabled="formField.foreigner_field && form.nationality === 'Bhutanese'">
              <input v-model="form.filled_form_fields[index].value" class="w-full input" type="text" v-if="formField.field.type === 'Text'" />
              <input v-model="form.filled_form_fields[index].value" class="w-full input" type="number" v-else-if="formField.field.type === 'Number'" />
              <input v-model="form.filled_form_fields[index].value" class="w-full input" type="date" v-else-if="formField.field.type === 'Date'" />
              <input @change="event => form.filled_form_fields[index].value = event.target.files[0]" class="w-full input-file" type="file" v-else-if="formField.field.type === 'File'" />
              <textarea v-model="form.filled_form_fields[index].value" class="w-full textarea" v-else-if="formField.field.type === 'Text Area'"></textarea>
              <div v-else-if="formField.field.type === 'Checkbox'">
                <fieldset v-for="option in formField.field.options" :key="option.id" class="flex items-center space-x-2">
                  <input v-model="form.filled_form_fields[index].value" :value="option.id" type="checkbox" class="checkbox">
                  <label class="text-sm">{{ option.value }}</label>
                </fieldset>
              </div>
              <div v-else-if="formField.field.type === 'Radio Button'">
                <fieldset v-for="option in formField.field.options" :key="option.id" class="flex items-center space-x-2">
                  <input v-model="form.filled_form_fields[index].value" :value="option.id" type="radio" class="radio">
                  <label class="text-sm">{{ option.value }}</label>
                </fieldset>
              </div>
              <select v-model="form.filled_form_fields[index].value" class="w-full dropdown" v-else-if="formField.field.type === 'Dropdown'">
                <option v-for="option in formField.field.options" :key="option.id">
                  {{ option.value }}
                </option>
              </select>
              <!-- error -->
              <div v-if="form.errors[`${formField.id}id`]" class="text-error mt-1 text-sm text-red-500">
                {{ form.errors[`${formField.id}id`] }}
              </div>
            </fieldset>
          </div>
        </div>
      </div>

      <div class="flex gap-x-3 mt-6 justify-end">
        <button type="submit" class="btn bg-green-500 text-white px-4 py-2 rounded-md hover:bg-green-600 focus:outline-none focus:ring-2 focus:ring-green-500 focus:ring-offset-2">Save</button>
        <Link href="/form/filledForm" class="btn bg-gray-200 text-gray-700 px-4 py-2 rounded-md hover:bg-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-500 focus:ring-offset-2">Cancel</Link>
      </div>
    </form>
  </div>
</template>

<script setup>
import { useForm, Link } from '@inertiajs/vue3';
import { computed, ref } from 'vue';

const props = defineProps({
  filledForm: Object
})

const approvals = computed(() => props.filledForm.approvals.sort((approvalA, approvalB) => approvalA.stage - approvalB.stage))

const formFields = ref(props.filledForm.raised_form.form_template.form_fields.sort((formFieldA, formFieldB) => formFieldA.field.index - formFieldB.field.index));

const form = useForm({
  _method: 'put',
  filled_form_fields: props.filledForm.raised_form.form_template.form_fields.sort((formFieldA, formFieldB) => formFieldA.field.index - formFieldB.field.index).map(
    (formField) => formField.field.type === 'Checkbox' ? { formField: formField, value: [] } : { formField: formField, value: null })
});
</script>

<style scoped>
.input, .textarea, .dropdown, .checkbox, .radio {
  @apply border-gray-300 rounded-md shadow-sm;
}
.input-file {
  @apply border-gray-300 rounded-md shadow-sm ;
}
.text-error {
  @apply text-sm text-red-500;
}
.btn {
  @apply transition duration-150 ease-in-out;
}
</style>
